# Tiny Tiny eRuby --- Utility 
# 	Copyright (c) 2000 Masatoshi SEKI 
#       You can redistribute it and/or modify it under the same term as Ruby.
# 	$Id: erb.rb,v 1.36 2000/07/19 16:22:28 mas Exp $
# 	$Author: mas $

require 'erb/erbl'

module ERbUtil
  class BGAttr
    def initialize(colors = ["#eeeeee", "#ffffff"])
      @colors = colors
      @cur = -1
    end

    public
    def succ
      @cur = (@cur+1) % @colors.size
    end
    
    public
    def to_s
      succ
      "bgcolor=\"#{@colors[@cur]}\""
    end
  end

  public
  def h(s)
    s.to_s.gsub(/&/, "&amp;").gsub(/\"/, "&quot;").gsub(/>/, "&gt;").gsub(/</, "&lt;")
  end
end

module ERbMethod
  private
  def load_erb(fname)
    erb = nil
    File.open(fname) do |f|
      erb = ERbLight.new(f.read)
    end
    erb
  end
  module_function :load_erb

  public
  def def_erb_method(methodname, erb)
    erb = load_erb(erb) if erb.kind_of? String
    module_eval("def #{methodname}\n" + erb.src + "\nend\n")
  end
  module_function :def_erb_method
end

