# Tiny Tiny eRuby --- String output 
# 	Copyright (c) 1999-2000 Masatoshi SEKI 
#       You can redistribute it and/or modify it under the same term as Ruby.
# 	$Id: strio.rb,v 1.7 2000/08/22 17:15:11 mas Exp $
# 	$Author: mas $

require 'thread'

class StringIO
  class DefOutClass
    def write(s)
      out = @writers.fetch(Thread.current, @default)
      out.write(s)
    end

    def set(obj)
      @m.synchronize do
	@writers[Thread.current] = obj
      end
    end

    def cleanup
      @m.synchronize do
	@writers.delete_if do |k, v|
	  not k.alive?
	end
      end
    end

    def initialize
      @m = Mutex.new
      @writers = Hash.new
      @default = $>
      $> = self
      @th = Thread.new {
	while true
	  sleep 60
	  $>.cleanup
	end
      }
      @writers.taint
      @default.taint
      taint
    end
  end

  DefOut = DefOutClass.new

  def initialize(str='')
    @str = str.to_s
    @str.taint
    taint
  end
  attr :str

  def write(str)
    @str.concat(str)
  end

  def self.as_stdout
    t = Thread.new {
      out = StringIO.new
      DefOut.set(out)
      yield
      out.str
    }
    DefOut.cleanup
    t.value
  end
end


